// FLATBTN.H - Declares the CFlatButton class.
// Author - Arnab Bhaduri
///////////////////////////////////////////////////////////////////

#ifndef __FLATBTN_H__
#define __FLATBTN_H__

class CFlatButton : public CButton
{
public:

    // Construction and destruction
    CFlatButton();
    virtual ~CFlatButton();

    // Operations
    BOOL SetMenu( HMENU hMenu );
    BOOL SetBitmap( HBITMAP hBitmap );

protected:

    // Attributes
    BOOL     m_bMouse;
    BOOL     m_bClick;
    BOOL     m_bMenu;
    int      m_nMenuAreaWidth;
    CMenu   *m_pMenu;
    CBitmap *m_pBitmap;

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CFlatButton)
public:
    virtual BOOL Create( LPCTSTR lpszWindowName, DWORD dwStyle, \
                         const RECT& rect, CWnd* pParentWnd,    \
                         UINT nID );
    virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
    //}}AFX_VIRTUAL

    // Generated message map functions
protected:
    //{{AFX_MSG(CFlatButton)
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
    //}}AFX_MSG

    // manually added
    afx_msg void OnCaptureChanged( CWnd* pWnd );

    DECLARE_MESSAGE_MAP()

    // helpers
    void GetMenuAreaRect( LPRECT pRect );
    void GetBtnAreaRect( LPRECT pRect );

    // parameters
    static int MenuFraction;
    static int BtnMargin;
    static int ArrowSize;
};

#endif // __FLATBTN_H__
