// MyPropSheet.cpp : implementation file
//

#include "stdafx.h"
#include "propsht.h"
#include "MyPropSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyPropSheet

IMPLEMENT_DYNAMIC(CMyPropSheet, CPropertySheet)

CMyPropSheet::CMyPropSheet(UINT nIDCaption,  BOOL bStdButton,CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_page1);
	AddPage(&m_page2);
	// tells whether standard buttons required or not
	m_bStdButton = bStdButton;
}

CMyPropSheet::CMyPropSheet(LPCTSTR pszCaption, BOOL bStdButton, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_page1);
	AddPage(&m_page2);
	// tells whether standard buttons required or not
	m_bStdButton = bStdButton;
}

CMyPropSheet::~CMyPropSheet()
{
}


BEGIN_MESSAGE_MAP(CMyPropSheet, CPropertySheet)
	//{{AFX_MSG_MAP(CMyPropSheet)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	ON_BN_CLICKED(IDCANCEL,OnOk)
	ON_BN_CLICKED(IDOK,OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyPropSheet message handlers

BOOL CMyPropSheet::OnInitDialog() 
{
	BOOL bModeless = m_bModeless;

	if( m_bStdButton )
	{	// we want standard buttons

		// We are using Create function which is modeless and MFC
		// OnInitDialog code for modeless removes the standard
		// buttons. But we want standard buttons in the modeless
		// so we fake by setting the m_bModeless to FALSE and then
		// restore it again after calling base class CPropertySheet
		// OnInitDialog()
		m_bModeless = FALSE;
	}

	BOOL bResult = CPropertySheet::OnInitDialog();
	
	if( m_bStdButton )
		m_bModeless = bModeless;  // restore the original setting


	return bResult;
}

void CMyPropSheet:: OnCancel()
{
	EndDialog(IDCANCEL);
	
}

void CMyPropSheet:: OnOk()
{
	EndDialog(IDOK);
}
