#include <windows.h>
#include <commdlg.h>
#include <windowsx.h>

static WNDPROC s_wndProcSaved = 0;

static LRESULT CALLBACK SubclassWndProc( 
    HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    const LRESULT lResult = CallWindowProc( 
        s_wndProcSaved, hwnd, msg, wParam, lParam );

    switch ( msg ) {
    case WM_SETTINGCHANGE:
    case WM_SYSCOLORCHANGE:
        SendMessage( GetDlgItem( hwnd, lst2 ), msg, wParam, lParam );
        break;
    case WM_NCDESTROY:
        SubclassWindow( hwnd, s_wndProcSaved );
        break;
    }
    
    return lResult;
}

static UINT CALLBACK HookProc( 
    HWND hwndChildDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch ( msg ) {
    case WM_SETTINGCHANGE:
    case WM_SYSCOLORCHANGE:
        DebugBreak(); // Never gets here.
        break;
    case WM_NOTIFY: 
        if ( CDN_INITDONE == ((LPNMHDR)lParam)->code ) {
            s_wndProcSaved = SubclassWindow( 
                GetParent( hwndChildDlg ), SubclassWndProc );
        }
        break;
    }
    
    return 0;
}

int APIENTRY WinMain( HINSTANCE hinst, HINSTANCE, LPSTR, int )
{
    char szPath[ MAX_PATH ] = "";
    OPENFILENAME ofn = { sizeof( OPENFILENAME ), 
        HWND_DESKTOP, 0, "All Files (*.*)\0*.*\0",
        0, 0, 1, szPath, sizeof szPath, 0, 0, 0, "Open File",
        OFN_EXPLORER | OFN_ENABLEHOOK, 
        0, 0, "txt", 0, HookProc, 0 };
    
    GetOpenFileName( &ofn );
    return 0;
}

// end of file
