/*
    Test Windows CE semaphore emulation
*/

#define STRICT
#include <windows.h>
#include <tchar.h>
#include <stdlib.h>
#include "wcesem.h"

SYNCHHANDLE g_hSem = NULL;

#define MAX_THREADS 64
#define QUEUE_SIZE  5

long g_iCurSize = 0;




void DebugOut(LPTSTR psz, ...)
{
    TCHAR    szbuf[256];
    va_list arglist;

    va_start(arglist, psz);

    wvsprintf(szbuf, psz, arglist);
    OutputDebugString(szbuf);

    va_end(arglist);

}


UINT WINAPI PrintJob(PVOID pv)
{
    long lPrev;

    WaitForSemaphoreCE(g_hSem, INFINITE);

    InterlockedIncrement(&g_iCurSize);

    DebugOut(_T("%08lX - entered queue: size = %d\n"), 
             GetCurrentThreadId(), g_iCurSize );

    Sleep(500);  // print job....

    InterlockedDecrement(&g_iCurSize);

    DebugOut(_T("%08lX - exited queue: size = %d\n"), 
             GetCurrentThreadId(), g_iCurSize );

    ReleaseSemaphoreCE(g_hSem, 1, &lPrev);

    return 0;
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, 
                    LPTSTR lpCmdLine, int nCmdShow ) 
{
    HANDLE hThreads[MAX_THREADS];
    UINT dwTID;
    int  i;

    g_hSem = CreateSemaphoreCE(NULL, QUEUE_SIZE, 
                               QUEUE_SIZE, NULL );

    for ( i = 0; i < MAX_THREADS; i++ )
        hThreads[i] =  CreateThread(NULL, 0, PrintJob, 
                                    NULL, 0, &dwTID);

    // CE does not support the all handles version of 
    // WaitForMultipleObjects so we do each handle in 
    // sequence instead
    for ( i = 0; i < MAX_THREADS; i++ )
        WaitForSingleObject(hThreads[i], INFINITE);

    return 0;
}

